#include "StdAfx.h"
#include "hourlyWorker.h"
#include <iostream>
using namespace std;

hourlyWorker::hourlyWorker(const string &first, const string &last,
	      double w, double h) : employee(first, last)
{
   setWage(w);
   setHours(h);
}
//*****************
void hourlyWorker::setWage(double w)
{
   wage = w > 0 ? w : 0;
}
//***************
void hourlyWorker::setHours(double h)
{
   hours = h >= 0 && h < 168 ? h : 0;
}
//*****************
double hourlyWorker::earnings() const
{
   if(hours <= 40) //no overtime
       return wage * hours;
   else
       return 40 * wage + (hours - 40) * wage * 1.5;
}
//*****************
void hourlyWorker::print() const
{
   cout << "\nhourly worker: ";
   employee::print();
}

