// Demonstrating standard new throwing bad_alloc when memory
// cannot be allocated.
#include "stdafx.h"
#include <iostream>
#include <new> // bad_alloc class is defined here
using namespace std;

int main()
{
   double *ptr[ 50 ];
   
   // aim each ptr[i] at a big block of memory
   try 
   {
      // allocate memory for ptr[ i ]; new throws bad_alloc on failure
      for ( int i = 0; i < 50; i++ ) 
      {
         ptr[ i ] = new double[ 50000000 ]; // may throw exception
         cout << "ptr[" << i << "] points to 50,000,000 new doubles\n";
      } // end for
   } // end try
   catch ( bad_alloc &memoryAllocationException )
   {
       cout << "Exception occurred: " 
         << memoryAllocationException.what() << endl;
   } // end catch
   cin.get();
} // end main
