// Definition of class gradeBank that uses a 
// two-dimensional array to store test grades.
// Member functions are defined in gradeBank.cpp
#include "stdafx.h"
#include <string> // program uses C++ Standard Library string class
using namespace std;

// gradeBank class definition
class gradeBank
{
public:
   // constants
   static const int students = 10; // number of students
   static const int tests = 3; // number of tests
 
   // constructor initializes course name and array of grades
   gradeBank( string, const int [][ tests ] );

   void setCourseName( string ); // function to set the course name
   string getCourseName(); // function to retrieve the course name
   void display(); // display a welcome message
   void gradeProcess(); // perform various operations on the grade data
   int getMinimum(); // find the minimum grade in the grade bank
   int getMaximum(); // find the maximum grade in the grade bank
   double getAverage( const int [], const int ); // get student's average
   void outputBarChart(); // output bar chart of grade distribution
   void outputGrades(); // output the contents of the grades array
private:
   string courseName; // course name for this grade book
   int grades[ students ][ tests ]; // two-dimensional array of grades
}; // end class GradeBook  
