#include "stdafx.h"
#include <iostream>
using namespace std;

class arrayClass
{
   friend ostream &operator<<( ostream &, const arrayClass & );
   friend istream &operator>>( istream &, arrayClass & );
public:
   arrayClass( int = 10 ); // default constructor
   arrayClass( const arrayClass & ); // copy constructor
   ~arrayClass(); // destructor
   int getSize() const; // return size

   const arrayClass &operator=( const arrayClass & ); // assignment operator
   bool operator==( const arrayClass & ) const; // equality operator

   // inequality operator; returns opposite of == operator
   bool operator!=( const arrayClass &right ) const  
   { 
      return ! ( *this == right ); // invokes arrayClass::operator==
   } // end function operator!=
   
   // subscript operator for non-const objects returns modifiable lvalue
   int &operator[]( int );              

   // subscript operator for const objects returns rvalue
   int operator[]( int ) const;  
private:
   int size; // pointer-based arrayClass size
   int *ptr; // pointer to first element of pointer-based arrayClass
}; // end class arrayClass
