#include "StdAfx.h"
#include "Date.h"
#include <string>
#include <iostream>
using namespace std;

//initialize static member at file scope
//one class-wide copy
const int Date::days[] = { 0, 31, 31, 31, 31, 31, 31,
			   30, 30, 30, 30, 30, 29 };
//Date constructor
//Date::Date(int m, int d, int y)
Date::Date(int d, int m, int y)
{
  setDate(d, m, y);
}
//****set the Date***********
//void Date::setDate(int mm, int dd, int yy)
void Date::setDate(int dd, int mm, int yy)
{
  month = (mm >= 1 && mm <= 12) ? mm : 1;
  year = (yy >= 1370 && yy <= 1400) ? yy : 1370;
       day = (dd >= 1 && dd <= days[month]) ? dd : 1;
}
//** preincrement operator overloaded as a member funtion.
Date &Date::operator++()
{
   helpIncrement();
   return *this; //reference return to create an lvalue
}
//*****post increment operator overloaded as a member function.
//note that the dummy integer parameter does not have
//a parameter name
Date Date::operator++(int)
{
  Date temp = *this;
  helpIncrement();
  //return non-incremented, save, temporary object
  return temp; //value return, not a reference return
}
//add a specific number of days to a Date
const Date &Date::operator+=(int ad)
{
  for(int i = 0; i < ad; i ++)
      helpIncrement();
  return *this;        //enables cascading
}
//*****determine if the day is the end of the month
bool Date::endOfMonth(int d)
{
      return d == days[month];
}
//function to help increment the Date
void Date::helpIncrement()
{
  if(endOfMonth(day) && month == 12) { // end year
     day = 1;
     month = 1;
     ++year;
  }
  else if(endOfMonth(day)) {    //end month
     day = 1;
     ++month;
  }
  else       //not end of month or year; increment day
     ++day;
}
//*overload output operator **********
ostream &operator<<(ostream &output, const Date &d)
{
   static char *monthName[13] = { "", "Farvardine",
     "Ordibehesht", "Khordad", "Tir", "Mordad", "Shahrivar",
     "Mehr", "Aban", "Azar", "Day",
     "Bahnman", "Esphand" };
   output << monthName[d.month] << ' '
	  << d.day << ", " << d.year;
   return output; //enables cascading
}
