#include "stdafx.h"
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdlib> // exit function prototype
#include "studentData.h" // studentData class definition

void outputLine( ostream&, const studentData & ); // prototype

int main()
{
   int studentNumber;
   string lastName;
   string firstName;
   double average;

   fstream outStudent( "student.dat", ios::out); //open file for output 

   // exit program if fstream cannot open file
   if ( !outStudent ) 
   {
      cerr << "File could not be opened." << endl;
	  cin.get();
      exit( 1 );
   } // end if

   cout << "Enter student number (1 to 100, 0 to end input)\n? ";
   // require user to specify account number
   studentData client;
   cin >> studentNumber;
   // user enters information, which is copied into file
   while ( studentNumber > 0 && studentNumber <= 100 ) 
   {
      // user enters last name, first name and balance
      cout << "Enter lastname, firstname, average\n? ";
      cin >> lastName;
      cin >> firstName;
      cin >> average;
	  cin.ignore(); //ignore the end of line character

      // set record studentNumber, lastName, firstName and average values
      client.setStudentNumber( studentNumber );
      client.setLastName( lastName );
      client.setFirstName( firstName );
      client.setAverage( average );
      // write user-specified information in file
      outStudent.write( ( char * ) ( &client ), sizeof( studentData ) );
      // enable user to enter another student number
      cout << "Enter student number\n? ";
      cin >> studentNumber;
	  cin.ignore();
   } // end while
   outStudent.close ();
   //open file for input
   ifstream inStudent( "student.dat", ios::in);

   // exit program if ifstream cannot open file
   if ( !inStudent ) 
   {
      cerr << "File could not be opened." << endl;
      exit( 1 );
   } // end if
   cout << "Student information read from file is :\n\n";
   cout << endl << left << setw( 10 ) << "Student" << setw( 16 )
      << "Last Name" << setw( 11 ) << "First Name" << left
      << setw( 10 ) << right << "Average" << endl;

   inStudent.read( ( char * )( &client ), sizeof( studentData ) );
   // read all records from file
   while ( inStudent && !inStudent.eof() ) 
   {
      // display record
      if ( client.getStudentNumber() != 0 )
         outputLine( cout, client );

      // read next from file
      inStudent.read( (char * )( &client ), sizeof( studentData ) );
   } // end while
   cin.get();
} // end main
//**************************************
void outputLine( ostream &output, const studentData &record )
{
   output << left << setw( 10 ) << record.getStudentNumber()
      << setw( 16 ) << record.getLastName()
      << setw( 11 ) << record.getFirstName()
      << setw( 10 ) << setprecision( 2 ) << right << fixed 
      << showpoint << record.getAverage() << endl;
} // end function outputLine


