#include "stdafx.h"
#include <iostream>
#include <fstream>
#include <iomanip>
#include <cstdlib> // exit function prototype
#include "studentData.h" // studentData class definition

void outputLine( ostream&, const studentData & ); // prototype

int main()
{
   int studentNumber;
   double average;

   fstream outTemp( "temp.dat", ios::out); //open temp  file for output 
   fstream input("student.dat", ios::in); 
   // exit program if fstream cannot open file
   if ( !outTemp || !input ) 
   {
      cerr << "File could not be opened." << endl;
	  cin.get();
      exit( 1 );
   } // end if

   studentData client;
   cout << "Enter student number (1 to 100, 0 ) to search)\n? ";
   // require user to specify student number  */
   cin >> studentNumber;
   cin.ignore(); //discard the end of line char
   input.read( ( char * )( &client ), sizeof( studentData ) );
   // read all records from file
   while ( input && !input.eof() ) 
   {
	   if (studentNumber == client.getStudentNumber())
	   {
		   cout << "Enter new average : ";
		   cin >> average;
     	   client.setAverage(average);
		   cin.ignore(); //discard the end of line character
	   }
	   outTemp.write((char *) &client, sizeof(studentData));
	   input.read( ( char * )( &client ), sizeof( studentData ) );
   } // end while
   input.close();
   outTemp.close();
   remove("student.dat");
   rename("temp.dat", "student.dat");
   //open file for input
   ifstream inStudent( "student.dat", ios::in);
   // exit program if ifstream cannot open file
   if ( !inStudent ) 
   {
      cerr << "File could not be opened." << endl;
	  cin.get();
      exit( 1 );
   } // end if
   cout << "Student information read from file is :\n\n";
   cout << endl << left << setw( 10 ) << "Student" << setw( 16 )
      << "Last Name" << setw( 11 ) << "First Name" << left
      << setw( 10 ) << right << "Average" << endl;

   inStudent.read( ( char * )( &client ), sizeof( studentData ) );
   // read all records from file
   while ( inStudent && !inStudent.eof() ) 
   {
      // display record
      if ( client.getStudentNumber() != 0 )
         outputLine( cout, client );

      // read next from file
      inStudent.read( (char *)( &client ), sizeof( studentData ) );
   } // end while
   cin.get();
} // end main
//**************************************
void outputLine( ostream &output, const studentData &record )
{
   output << left << setw( 10 ) << record.getStudentNumber()
      << setw( 16 ) << record.getLastName()
      << setw( 11 ) << record.getFirstName()
      << setw( 10 ) << setprecision( 2 ) << right << fixed 
      << showpoint << record.getAverage() << endl;
} // end function outputLine


